import path from 'path'
import fs from 'fs-extra'
// 客户端地址
const CLIENT_PATH = path.resolve(__dirname, '../../')

// 项目目录
const PROJECT_PATH = process.cwd()

// 项目源码目录
const SRC_PATH = PROJECT_PATH + '/src'
function deleteFolder (path) {
  if (fs.existsSync(path)) {
    fs.readdirSync(path).forEach(function (file) {
      var curPath = path + '/' + file
      if (fs.statSync(curPath).isDirectory()) { // recurse
        deleteFolder(curPath)
      } else { // delete file
        fs.unlinkSync(curPath)
      }
    })
    fs.rmdirSync(path)
  }
}
export default {
  CLIENT_PATH,
  PROJECT_PATH,
  SRC_PATH,
  API_PATH: SRC_PATH + '/api',
  SRC_ROUTER_PATH: SRC_PATH + '/router',
  SRC_VIEW_PATH: SRC_PATH + '/views',
  firstUpperCase (str) {
    return str.replace(/( |^)[a-z]/g, (L) => L.toUpperCase())
  },
  firstLowerCase (str) {
    return str.replace(/( |^)[a-z]/g, (L) => L.toLowerCase())
  },
  deleteFolder
}
