'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _tools = require('./../utils/tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * desc:增加一个页面 newPage
 *
 * 1.在api下生成api访问js
 *      -api
 *          -newPage.js
 *
 * 2.在api/index.js增加路由引入
 *
 */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(pageNames) {
    var _loop, i, len, pageName;

    return _regenerator2.default.wrap(function _callee2$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop(i, len) {
              var lowerPageName, apiFile, apiTemplateFile, apiTemplateFileData, importApiStr, apiIndexFile, apiIndexCopyTemplateFile, apiIndexReadStream, apiIndexCopyWriteStream, apiFileReadline, index;
              return _regenerator2.default.wrap(function _loop$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      pageName = pageNames[i];

                      // 1.在api下生成api访问js

                      // 首字母小写文件名

                      lowerPageName = (0, _tools.firstLowerCase)(pageName);
                      apiFile = _tools.API_PATH + '/' + lowerPageName + '.js';
                      apiTemplateFile = _tools.CLIENT_PATH + '/template/api.js';

                      // 读取api文件模版读取api文件模版

                      _context2.next = 6;
                      return _fsExtra2.default.readFile(apiTemplateFile);

                    case 6:
                      apiTemplateFileData = _context2.sent;


                      _fsExtra2.default.writeFileSync(apiFile, _ejs2.default.render(apiTemplateFileData.toString(), {
                        lowerPageName: lowerPageName
                      }));

                      // 2.在api/index.js增加路由引入

                      // 导入的API
                      importApiStr = 'import ' + lowerPageName + ' from \'./' + lowerPageName + '\'';
                      apiIndexFile = _tools.API_PATH + '/index.js';
                      apiIndexCopyTemplateFile = _tools.CLIENT_PATH + '/template/api-index-copy.js';

                      // 同步创建api-index-copy.js

                      _fsExtra2.default.writeFileSync(apiIndexCopyTemplateFile);

                      // 打开apiIndexFile可读的文件流
                      apiIndexReadStream = _fsExtra2.default.createReadStream(apiIndexFile);

                      // 创建routerCopyFile可写的文件流

                      apiIndexCopyWriteStream = _fsExtra2.default.createWriteStream(apiIndexCopyTemplateFile);

                      // 创建一个可逐行读取流
                      // input - 需要监听的可读流

                      apiFileReadline = _readline2.default.createInterface({
                        input: apiIndexReadStream
                      });
                      index = 0;
                      _context2.next = 18;
                      return apiFileReadline.on('line', function () {
                        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(line) {
                          var beforeStr, insertStr;
                          return _regenerator2.default.wrap(function _callee$(_context) {
                            while (1) {
                              switch (_context.prev = _context.next) {
                                case 0:
                                  beforeStr = '';

                                  if (index == 0) {
                                    index++;
                                  } else {
                                    beforeStr = _os2.default.EOL;
                                  }
                                  insertStr = '';

                                  if (line.indexOf('export default') > -1) {
                                    insertStr = beforeStr + importApiStr + _os2.default.EOL + line + _os2.default.EOL + '  ' + lowerPageName + ',';
                                  } else {
                                    insertStr = beforeStr + line;
                                  }
                                  _context.next = 6;
                                  return apiIndexCopyWriteStream.write(insertStr);

                                case 6:
                                case 'end':
                                  return _context.stop();
                              }
                            }
                          }, _callee, undefined);
                        }));

                        return function (_x2) {
                          return _ref2.apply(this, arguments);
                        };
                      }());

                    case 18:
                      _context2.next = 20;
                      return _fsExtra2.default.copy(apiIndexCopyTemplateFile, apiIndexFile);

                    case 20:
                      _context2.next = 22;
                      return _fsExtra2.default.unlink(apiIndexCopyTemplateFile);

                    case 22:

                      console.log(_colors2.default.magenta('visit api file :' + apiFile));

                    case 23:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, _loop, undefined);
            });
            i = 0, len = pageNames.length;

          case 2:
            if (!(i < len)) {
              _context3.next = 7;
              break;
            }

            return _context3.delegateYield(_loop(i, len), 't0', 4);

          case 4:
            i++;
            _context3.next = 2;
            break;

          case 7:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];