'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _ip = require('ip');

var _ip2 = _interopRequireDefault(_ip);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _ejs = require('ejs');

var _ejs2 = _interopRequireDefault(_ejs);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _tools = require('./../utils/tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * desc:增加一个页面 newPage
 *
 * 1.在view下生成页面
 *      -view
 *          -NewPage
 *              -Index.vue
 * 2.在router增加路由引入
 *
 */
// export default pageNames => pageNames.forEach(async pageName => {
//     console.log(pageName);
//     await sleep(3000);
//     console.log(124);
// })
// export default async (pageNames) => {
//     for (let i = 0, len = pageNames.length; i < len; i++) {
//         var pageName = pageNames[i];
//         console.log(pageName);
//         await sleep(3000);
//         console.log(124);
//     }
// }
var devPort = require(_tools.PROJECT_PATH + '/package.json').vivo.devPort;

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(pageNames) {
    var _loop, i, len, pageName;

    return _regenerator2.default.wrap(function _callee2$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop(i, len) {
              var upperPageName, lowerPageName, newPageFile, newPageTemplateFile, newPageTemplateData, newPageTemplateStr, routerFile, routerCopyFile, routerFileReadStream, routerCopyFileWriteStream, importRouterStr, routerObjectStr, routerFileReadline, index;
              return _regenerator2.default.wrap(function _loop$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      pageName = pageNames[i];

                      // 1.在view下生成页面对应的文件

                      // 首字母大写文件名

                      upperPageName = (0, _tools.firstUpperCase)(pageName);

                      // 首字母小写文件名

                      lowerPageName = (0, _tools.firstLowerCase)(pageName);

                      // 新页面

                      newPageFile = _tools.SRC_VIEW_PATH + '/' + upperPageName + '/Index.vue';

                      // 新页面模版

                      newPageTemplateFile = _tools.CLIENT_PATH + '/template/page.vue';

                      // 读取模版字符串

                      _context2.next = 7;
                      return _fsExtra2.default.readFile(newPageTemplateFile);

                    case 7:
                      newPageTemplateData = _context2.sent;
                      _context2.next = 10;
                      return _ejs2.default.render(newPageTemplateData.toString(), {
                        upperPageName: upperPageName,
                        lowerPageName: lowerPageName
                      });

                    case 10:
                      newPageTemplateStr = _context2.sent;
                      _context2.next = 13;
                      return _fsExtra2.default.outputFile(newPageFile, newPageTemplateStr);

                    case 13:

                      // 2.在router增加路由引入

                      // 生成router.js
                      routerFile = _tools.SRC_ROUTER_PATH + '/index.js';

                      // 拷贝的router.js后的地址

                      routerCopyFile = _tools.CLIENT_PATH + '/template/router-copy.js';

                      // 同步创建router-copy.js

                      _fsExtra2.default.writeFileSync(routerCopyFile);

                      // 打开routerFile可读的文件流
                      _context2.next = 18;
                      return _fsExtra2.default.createReadStream(routerFile);

                    case 18:
                      routerFileReadStream = _context2.sent;
                      _context2.next = 21;
                      return _fsExtra2.default.createWriteStream(routerCopyFile);

                    case 21:
                      routerCopyFileWriteStream = _context2.sent;


                      // 创建的路由字符串
                      // 导入新建的路由字符串
                      importRouterStr = 'const ' + upperPageName + ' = resolve => require([\'../views/' + upperPageName + '/Index\'], resolve)';

                      // 路由对象字符串

                      routerObjectStr = '\n    {\n      path: \'/' + lowerPageName + '\',\n      name: \'' + upperPageName + '\',\n      meta: {\n        title: \'' + upperPageName + '\'\n      },\n      component: ' + upperPageName + '\n    },';

                      // 创建一个可逐行读取流
                      // input - 需要监听的可读流

                      _context2.next = 26;
                      return _readline2.default.createInterface({
                        input: routerFileReadStream
                      });

                    case 26:
                      routerFileReadline = _context2.sent;


                      // 按行将需要插入的字符串插入至临时文件中
                      // 判断是否是首航标示
                      index = 0;
                      _context2.next = 30;
                      return routerFileReadline.on('line', function () {
                        var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(line) {
                          var beforeStr, insetStr;
                          return _regenerator2.default.wrap(function _callee$(_context) {
                            while (1) {
                              switch (_context.prev = _context.next) {
                                case 0:
                                  beforeStr = '';
                                  // 如果不是首行，则添加系统换行符

                                  if (index > 0) {
                                    beforeStr = _os2.default.EOL;
                                  }

                                  // 行数递增
                                  index++;

                                  // 声明插入的字符
                                  insetStr = '';

                                  if (line.indexOf('new Router') > -1) {
                                    // 判断到声明路由时，插入importRouterStr
                                    insetStr = beforeStr + importRouterStr + _os2.default.EOL + line;
                                  } else if (line.replace(/\s/g, '').indexOf('routes:[') > -1) {
                                    // 判断路由对象数组时，插入routerObjectStr
                                    insetStr = beforeStr + line + routerObjectStr;
                                  } else {
                                    // 其他则还原
                                    insetStr = beforeStr + line;
                                  }
                                  _context.next = 7;
                                  return routerCopyFileWriteStream.write(insetStr);

                                case 7:
                                case 'end':
                                  return _context.stop();
                              }
                            }
                          }, _callee, undefined);
                        }));

                        return function (_x2) {
                          return _ref2.apply(this, arguments);
                        };
                      }());

                    case 30:
                      _context2.next = 32;
                      return _fsExtra2.default.copy(routerCopyFile, routerFile);

                    case 32:
                      _context2.next = 34;
                      return _fsExtra2.default.appendFile(routerFile, _os2.default.EOL);

                    case 34:
                      _context2.next = 36;
                      return _fsExtra2.default.unlink(routerCopyFile);

                    case 36:

                      console.log(_colors2.default.magenta('visit page file :' + newPageFile));
                      console.log(_colors2.default.green('visit page url : http://' + _ip2.default.address() + ':' + devPort + '/#/' + lowerPageName));

                    case 38:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, _loop, undefined);
            });
            i = 0, len = pageNames.length;

          case 2:
            if (!(i < len)) {
              _context3.next = 7;
              break;
            }

            return _context3.delegateYield(_loop(i, len), 't0', 4);

          case 4:
            i++;
            _context3.next = 2;
            break;

          case 7:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();

module.exports = exports['default'];