'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

var _colors = require('colors');

var _colors2 = _interopRequireDefault(_colors);

var _tools = require('./../utils/tools');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var exec = require('child_process').execSync;
var ora = require('ora');
var getGitUser = require('./../utils/git-user');
var spinner = ora('正在备份工作区代码');

exports.default = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
  var copyName, sysProjectPath, localPackage, localDendencies, localDevDendencies, userPackage, userDendencies, userDevDendencies, cache, key, localVersion, _userVserion, _key, _localVersion, userVserion, updatePackageFile, updateBuildFile, useBuildFile, updateGulpFile, useGulpfile, updateReadme, useReadme, updateEslintignore, useEslintignore, updateEslintrc, useEslintrc;

  return _regenerator2.default.wrap(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          spinner.start();
          // 备份用户所有代码
          copyName = 'copy_' + +new Date();
          _context.next = 4;
          return _fsExtra2.default.copy(_tools.PROJECT_PATH + '/', _tools.CLIENT_PATH + '/' + copyName);

        case 4:
          _context.next = 6;
          return _fsExtra2.default.copy(_tools.CLIENT_PATH + '/' + copyName, _tools.PROJECT_PATH + '/' + copyName);

        case 6:
          spinner.text = '备份完毕';
          spinner.succeed();
          (0, _tools.deleteFolder)(_tools.CLIENT_PATH + '/' + copyName);

          // 比对package.json
          // dependencies
          // devDependencies

          exec('cd ' + _tools.CLIENT_PATH + '/project && git clone -b vue-init ssh://' + getGitUser().name + '@smartgit:29418/mobileInternet/core/FED/public ');
          sysProjectPath = _tools.CLIENT_PATH + '/project/public/vue-init/src/project';

          // 读取本地package.json

          localPackage = _fsExtra2.default.readJsonSync(sysProjectPath + '/package.json');
          localDendencies = localPackage.dependencies;
          localDevDendencies = localPackage.devDependencies;

          // 读取用户package.json

          userPackage = _fsExtra2.default.readJsonSync(_tools.PROJECT_PATH + '/package.json');
          userDendencies = userPackage.dependencies;
          userDevDendencies = userPackage.devDependencies;
          cache = {
            dependencies: {},
            devDependencies: {}
          };


          for (key in localDendencies) {
            localVersion = localDendencies[key];

            if (userDendencies.hasOwnProperty(key)) {
              _userVserion = userDendencies[key];
              // 如果本地版本大于用户版本，则使用本地版本

              if (localVersion > _userVserion) {
                cache.dependencies[key] = _userVserion + '=>' + localVersion;
                userDendencies[key] = localVersion;
              }
            } else {
              cache.dependencies[key] = ' new =>' + localVersion;
              userDendencies[key] = localVersion;
            }
          }

          for (_key in localDevDendencies) {
            _localVersion = localDevDendencies[_key];

            if (userDevDendencies.hasOwnProperty(_key)) {
              userVserion = userDevDendencies[_key];
              // 如果本地版本大于用户版本，则使用本地版本

              if (_localVersion > userVserion) {
                cache.devDependencies[_key] = userVserion + '=>' + _localVersion;
                userDevDendencies[_key] = _localVersion;
              }
            } else {
              cache.devDependencies[_key] = ' new =>' + _localVersion;
              userDevDendencies[_key] = _localVersion;
            }
          }

          // 更新scripts
          userPackage.scripts = localPackage.scripts;

          updatePackageFile = _tools.CLIENT_PATH + '/template/update-package.json';

          _fsExtra2.default.writeJsonSync(updatePackageFile, userPackage, {
            spaces: '  '
          });

          // 更新package.json
          _context.next = 25;
          return _fsExtra2.default.copy(updatePackageFile, _tools.PROJECT_PATH + '/package.json', { overwrite: true }, function (err) {
            if (err) return console.error(err);
            console.log('本次package.json的依赖的更新：');
            console.log((0, _stringify2.default)(cache, null, '   '));
          });

        case 25:

          // 更新build
          updateBuildFile = sysProjectPath + '/build';
          useBuildFile = _tools.PROJECT_PATH + '/build';
          _context.next = 29;
          return _fsExtra2.default.remove(useBuildFile);

        case 29:
          _context.next = 31;
          return _fsExtra2.default.copy(updateBuildFile, useBuildFile).then(function () {
            console.log(useBuildFile + ' \u5DF2\u66F4\u65B0');
          });

        case 31:

          // 更新gulpfile.js
          updateGulpFile = sysProjectPath + '/gulpfile.js';
          useGulpfile = _tools.PROJECT_PATH + '/gulpfile.js';
          _context.next = 35;
          return _fsExtra2.default.copy(updateGulpFile, useGulpfile).then(function () {
            console.log(useGulpfile + ' \u5DF2\u66F4\u65B0');
          });

        case 35:

          // 更新readme
          updateReadme = sysProjectPath + '/readme.md';
          useReadme = _tools.PROJECT_PATH + '/readme.md';
          _context.next = 39;
          return _fsExtra2.default.copy(updateReadme, useReadme).then(function () {
            console.log(useReadme + ' \u5DF2\u66F4\u65B0');
          });

        case 39:

          // 更新eslintignore
          updateEslintignore = sysProjectPath + '/.eslintignore';
          useEslintignore = _tools.PROJECT_PATH + '/.eslintignore';
          _context.next = 43;
          return _fsExtra2.default.copy(updateEslintignore, useEslintignore).then(function () {
            console.log(useEslintignore + ' \u5DF2\u66F4\u65B0');
          });

        case 43:

          // 更新eslintrc
          updateEslintrc = sysProjectPath + '/.eslintrc.js';
          useEslintrc = _tools.PROJECT_PATH + '/.eslintrc.js';
          _context.next = 47;
          return _fsExtra2.default.copy(updateEslintrc, useEslintrc).then(function () {
            console.log(useEslintrc + ' \u5DF2\u66F4\u65B0');
          });

        case 47:
          _context.next = 49;
          return _fsExtra2.default.remove(_tools.PROJECT_PATH + '/node_modules');

        case 49:

          console.log(_colors2.default.magenta('Project updated successfully !\nPlease run `npm i` '));

          // 移除临时文件夹
          _fsExtra2.default.remove(_tools.CLIENT_PATH + '/project/public');

        case 51:
        case 'end':
          return _context.stop();
      }
    }
  }, _callee, undefined);
}));
module.exports = exports['default'];