'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _fsExtra = require('fs-extra');

var _fsExtra2 = _interopRequireDefault(_fsExtra);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// 客户端地址
var CLIENT_PATH = _path2.default.resolve(__dirname, '../../');

// 项目目录
var PROJECT_PATH = process.cwd();

// 项目源码目录
var SRC_PATH = PROJECT_PATH + '/src';
function deleteFolder(path) {
  if (_fsExtra2.default.existsSync(path)) {
    _fsExtra2.default.readdirSync(path).forEach(function (file) {
      var curPath = path + '/' + file;
      if (_fsExtra2.default.statSync(curPath).isDirectory()) {
        // recurse
        deleteFolder(curPath);
      } else {
        // delete file
        _fsExtra2.default.unlinkSync(curPath);
      }
    });
    _fsExtra2.default.rmdirSync(path);
  }
}
exports.default = {
  CLIENT_PATH: CLIENT_PATH,
  PROJECT_PATH: PROJECT_PATH,
  SRC_PATH: SRC_PATH,
  API_PATH: SRC_PATH + '/api',
  SRC_ROUTER_PATH: SRC_PATH + '/router',
  SRC_VIEW_PATH: SRC_PATH + '/views',
  firstUpperCase: function firstUpperCase(str) {
    return str.replace(/( |^)[a-z]/g, function (L) {
      return L.toUpperCase();
    });
  },
  firstLowerCase: function firstLowerCase(str) {
    return str.replace(/( |^)[a-z]/g, function (L) {
      return L.toLowerCase();
    });
  },

  deleteFolder: deleteFolder
};
module.exports = exports['default'];